// USB Listener thread
USBListener usbEvent;
byte[] input_buffer = new byte[64];
byte[] output_buffer = new byte[65];

private class USBListener extends Thread 
{
  public void run()
  {
    while(true)
    {
        if(picConnected){
          try
          {
            int datalen=0;
            int i=0;
            
            pic.read(input_buffer);
            
            // The number of meaningful bytes is
            // stored in the zeroth byte
            datalen = (int)input_buffer[0];

            // The zeroth byte of the output_buffer is the report ID
            // This number is not seen by the receiving device
            output_buffer[0] = 0;
            
            // The first byte of the output_buffer is the descriptor byte
            output_buffer[1] = (byte)datalen;
            
            for(i=1;i<=datalen;i++){
                output_buffer[i+1] = input_buffer[i];
                print((char)input_buffer[i]);
            }
                       
            pic.write(output_buffer);    

            } catch (Exception e) {
            if(picConnected) e.printStackTrace();
            println("Cannot Read From Device");
          }
        }
    }
  }
}
